// $Id: Loader.cc,v 1.3.2.1 1998/09/22 07:43:31 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Loader.h"
#include "Log.h"

#include <iostream.h>

/* LoadInfo */

ostream &LoadInfo::print(ostream &os) const {
	// delta
	if (theDelta > 0)
		os << '+' << theDelta;
	else
	if (theDelta < 0)
		os << theDelta;
	else
	if (theLevel < 0) // invalid setting
		os << "invalid load";

	if (theLevel >= 0)
		os << '=' << theLevel;
	return os;
}

/* Loader */

void Loader::start() {
	Notepad << "loader " << name() << ' ' << this << " started" << ende;
	warmUp();
}

void Loader::done() {
	Notepad << "loader " << name() << ' ' << this << " stopped" << ende;
}

void Loader::changeLoad(const LoadInfo &li) {
	Assert(theLoadee);
	Notepad << "loader " << name() << ": " << theLoadee << "->changeLoad(" << li << ')' << ende;
	if (!theLoadee->gone())
		theLoadee->changeLoad(li);
}
