// $Id: LocalStats.cc,v 1.10.2.1 1998/09/22 07:43:31 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "Stats.h"
#include "StatShooters.h"
#include "RateMeter.h"

ValueStore stSelectDelay = 0;
static ValStShooter shSelectDelay(&stSelectDelay, "dSel");

// approximation of all IO time (read/write) within one loop
ValueStore stIOEvDelay = 0;
//static ValStShooter shIOEvDelay(&stIOEvDelay, "dIOEvs");

ValueStore stEvQueueDelay = 0;
//static ValStShooter shEvQueueDelay(&stEvQueueDelay, "dQueue");

ValueStore stMainLoopDelay = 0;
//static ValStShooter shMainLoopDelay(&stMainLoopDelay, "dLoop");

EventCounter stEventCount = 0;
//static EvCntShooter shEventCount(&stEventCount, "evnts");

ValueStore stSelectReadSetCount = 0;
//static ValStShooter shSelectReadSetCount(&stSelectReadSetCount, "setR");

ValueStore stSelectWriteSetCount = 0;
//static ValStShooter shSelectWriteSetCount(&stSelectWriteSetCount, "setW");

ValueStore stSelectReadReadyCount = 0;
//static ValStShooter shSelectReadReadyCount(&stSelectReadReadyCount, "readyR");

ValueStore stSelectWriteReadyCount = 0;
//static ValStShooter shSelectWriteReadyCount(&stSelectWriteReadyCount, "readyW");

LevelMeter stCcLevel;
//static LvlMtrShooter shCcLevel(&stCcLevel, "cc x level");

EventCounter stSubmCount = 0;
//static EvCntShooter shSubmCount(&stSubmCount, "subm");

EventCounter stComplCount = 0;
//static EvCntShooter shComplCount(&stComplCount, "compl");

EventCounter stErrCount = 0;
//static EvCntShooter shErrCount(&stErrCount, "errs");

LevelMeter stConnLevel;
//static LvlMtrShooter shConnLevel(&stConnLevel, "cc conn level");

// used for both ::accept and ::connect
EventShortCounter stOpenCount = 0;
static EvShCntShooter shOpenCount(&stOpenCount, "opens");

EventShortCounter stReadCount = 0;
static EvShCntShooter shReadCount(&stReadCount, "reads");

EventShortCounter stWriteCount = 0;
static EvShCntShooter shWriteCount(&stWriteCount, "writes");

EventShortCounter stCloseCount = 0;
static EvShCntShooter shCloseCount(&stCloseCount, "closes");

// used for ::create, ::connect, and ::accept
EventShortCounter stOpenErrCount = 0;
static EvShCntShooter shOpenErrCount(&stOpenErrCount, "opErrs");

// global "progress" meters 
RateMeter TheSubmMeter;
RateMeter TheComplMeter;
RateMeter TheErrMeter;

// true if none of the important stat objects holds "valid" values
bool StatsIdle() {
	return !(
		stSelectReadSetCount ||
		stSelectWriteSetCount ||
		stSelectReadReadyCount ||
		stSelectWriteReadyCount ||
		stSubmCount ||
		stComplCount ||
		stOpenCount ||
		stReadCount ||
		stWriteCount ||
		stCloseCount);
}
