// $Id: RateMeter.cc,v 1.2.2.3 1998/10/16 02:20:45 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "RateMeter.h"
#include "Clock.h"
#include "Gadgets.h"

void RateMeter::tick() {
	if (!theCount++)
		theFirstTime = TheClock;
	theLastTime = TheClock;
}

RateMeter &RateMeter::operator +=(const RateMeter &rm) {

	if (!rm.theCount)
		return *this;

	if (!theCount) {
		theFirstTime = rm.theFirstTime;
		theLastTime = rm.theLastTime;
	} else {
		theFirstTime = min(theFirstTime, rm.theFirstTime);
		theLastTime = max(theLastTime, rm.theLastTime);
	}

	theCount += rm.theCount;
	return *this;
}

RateMeter &RateMeter::operator -=(const RateMeter &rm) {

	if (!rm.theCount)
		return *this;

	// can subtract only when rm is included in our range
	assert(rm.theCount <= theCount); // thus, theCount > 0
	assert(rm.theFirstTime >= theFirstTime);
	assert(rm.theLastTime <= theLastTime);

	if (theFirstTime == rm.theFirstTime)
		theFirstTime = rm.theLastTime;
	if (theLastTime == rm.theLastTime)
		theLastTime = rm.theFirstTime;

	theCount -= rm.theCount;
	return *this;
}
