// $Id: SafePtrExample.cc,v 1.1.2.1 1998/09/22 07:43:40 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include <iostream.h>
#include <iomanip.h>

class T;

typedef T *Pointee;

#include "SafePtr.h"

// thread
struct T {
	T(int n): resource(n), self(this) {}

	int resource;
	SelfPtr self;
};

// distant manager
struct M {
	M(int n) { threads = new SmartPtr[count = n]; }
	~M() { delete[] threads; }

	int count;
	SmartPtr *threads;
};

int main(int, char*[]) {

	M *m1 = new M(50);
	M *m2 = new M(50);
	T *t = new T(12345);

	for (int i = 0; i < m1->count; ++i)
		m1->threads[i] = t->self;
	t->resource = 54321;
	for (int i = 0; i < m2->count; ++i)
		m2->threads[i] = t->self;

	cerr << "1)  t.resource: " << t->resource << endl;
	cerr << "1) m1.resource: " << m1->threads[25]->resource << endl;
	cerr << "1) m2.resource: " << m2->threads[25]->resource << endl;

	m1->threads[25]->resource = 222;
	delete m1;
		
	if (!m2->threads[25])
		cerr << "bug!" << endl;
	else
		cerr << "ok" << endl;

	cerr << "2)  t.resource: " << t->resource << endl;
	cerr << "2) m2.resource: " << m2->threads[25]->resource << endl;
		
	t->resource = 3333;
	cerr << "3)  t.resource: " << t->resource << endl;
	cerr << "3) m2.resource: " << m2->threads[25]->resource << endl;

	delete t;

	if (m2->threads[25])
		cerr << "bug!" << endl;
	else
		cerr << "ok" << endl;

	delete m2;
}
