// $Id: ErrHist.h,v 1.1.2.2 1998/09/22 07:44:04 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _ERR_HIST_H_
#define _ERR_HIST_H_

#include "Hist.h"

// histogram for "errno"s and, possibly custom errors
class ErrHist: public Hist {
	public:
		ErrHist(const char *aLabel, int aCapacity = 255): Hist(aLabel, aCapacity) {}

	protected:
		virtual const char *itemStr(int idx) const;
};

// custom errors
enum { E_CUSTOM_FIRST = 256, E_FOREIGN_REP = E_CUSTOM_FIRST, E_FOREIGN_REQ, E_EARLY_REP_END, E_EARLY_REQ_END, E_CUSTOM_END };

extern ErrHist TheErrHist; // global error accounting

#endif
