// $Id: xlogr.cc,v 1.1.2.1 1998/09/22 07:43:52 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"

#include <fstream.h>
#include <iomanip.h>

#include "XactLog.h"
#include "Gadgets.h"

static
void printXactLog(const char *fname) {
	cerr << " reading xlog from " << fname << endl;

	ifstream is(fname);
	const bool ok = TheXactLog.print(is, cout);

	if (!is.good())
		cerr << "error reading " << fname << endl;
	else
	if (!ok)
		cerr << "error parsing " << fname << endl;

	is.close();
}

static
int usage(const char *prg_name) {
	cerr << "usage: " << prg_name
		<< " <xlog_file_name> ..."
		<< endl;
	return -1;
}

int main(int argc, char *argv[]) {

	if (argc < 2)
		return usage(argv[0]);

	for (int i = 1; i < argc; ++i)
		printXactLog(argv[i]);

	return 0;
}
